Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/BasicUpdateView.Designer.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/BasicUpdateView.Designer.cs	(revision 3547)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/BasicUpdateView.Designer.cs	(revision 3547)
@@ -0,0 +1,78 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+namespace HeuristicLab.PluginInfrastructure.Advanced {
+  internal partial class BasicUpdateView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.updateAndInstallButton = new System.Windows.Forms.Button();
+      this.SuspendLayout();
+      // 
+      // updateAndInstallButton
+      // 
+      this.updateAndInstallButton.Anchor = System.Windows.Forms.AnchorStyles.None;
+      this.updateAndInstallButton.Image = global::HeuristicLab.PluginInfrastructure.Properties.Resources.VS2008ImageLibrary_Objects_Internet;
+      this.updateAndInstallButton.Location = new System.Drawing.Point(3, 2);
+      this.updateAndInstallButton.Name = "updateAndInstallButton";
+      this.updateAndInstallButton.Size = new System.Drawing.Size(155, 50);
+      this.updateAndInstallButton.TabIndex = 0;
+      this.updateAndInstallButton.Text = "Find and Install Updates";
+      this.updateAndInstallButton.TextImageRelation = System.Windows.Forms.TextImageRelation.ImageAboveText;
+      this.updateAndInstallButton.UseVisualStyleBackColor = true;
+      this.updateAndInstallButton.Click += new System.EventHandler(this.updateAndInstallButton_Click);
+      // 
+      // BasicUpdateView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.updateAndInstallButton);
+      this.Name = "BasicUpdateView";
+      this.Size = new System.Drawing.Size(163, 55);
+      this.ResumeLayout(false);
+
+    }
+
+    #endregion
+
+    private System.Windows.Forms.Button updateAndInstallButton;
+  }
+}
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/BasicUpdateView.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/BasicUpdateView.cs	(revision 3547)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/BasicUpdateView.cs	(revision 3547)
@@ -0,0 +1,110 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.PluginInfrastructure.Manager;
+
+namespace HeuristicLab.PluginInfrastructure.Advanced {
+  internal partial class BasicUpdateView : InstallationManagerControl {
+    private BackgroundWorker updatePluginsBackgroundWorker;
+    private const string CheckingPluginsMessage = "Checking for updated plugins...";
+    private const string NoUpdatesAvailableMessage = "No updates available.";
+
+    private PluginManager pluginManager;
+    public PluginManager PluginManager {
+      get { return pluginManager; }
+      set { pluginManager = value; }
+    }
+
+    private InstallationManager installationManager;
+    public InstallationManager InstallationManager {
+      get { return installationManager; }
+      set { installationManager = value; }
+    }
+
+    public BasicUpdateView() {
+      InitializeComponent();
+      updatePluginsBackgroundWorker = new BackgroundWorker();
+      updatePluginsBackgroundWorker.DoWork += new DoWorkEventHandler(updatePluginsBackgroundWorker_DoWork);
+      updatePluginsBackgroundWorker.RunWorkerCompleted += new RunWorkerCompletedEventHandler(updatePluginsBackgroundWorker_RunWorkerCompleted);
+    }
+
+    #region event handlers for update plugins backgroundworker
+    void updatePluginsBackgroundWorker_RunWorkerCompleted(object sender, RunWorkerCompletedEventArgs e) {
+      if (e.Error != null) {
+        StatusView.ShowError("Connection Error",
+          "There was an error while connecting to the server." + Environment.NewLine +
+           "Please check your connection settings and user credentials.");
+      } else if (e.Cancelled) {
+        StatusView.ShowMessage(NoUpdatesAvailableMessage);
+      }
+      StatusView.RemoveMessage(CheckingPluginsMessage);
+      StatusView.HideProgressIndicator();
+      StatusView.UnlockUI();
+    }
+
+    void updatePluginsBackgroundWorker_DoWork(object sender, DoWorkEventArgs e) {
+      IEnumerable<IPluginDescription> installedPlugins = (IEnumerable<IPluginDescription>)e.Argument;
+      var remotePlugins = installationManager.GetRemotePluginList();
+      // if there is a local plugin with same name and same major and minor version then it's an update
+      var pluginsToUpdate = from remotePlugin in remotePlugins
+                            let matchingLocalPlugins = from installedPlugin in installedPlugins
+                                                       where installedPlugin.Name == remotePlugin.Name
+                                                       where installedPlugin.Version.Major == remotePlugin.Version.Major
+                                                       where installedPlugin.Version.Minor == remotePlugin.Version.Minor
+                                                       where IsNewerThan(remotePlugin, installedPlugin)
+                                                       select installedPlugin
+                            where matchingLocalPlugins.Count() > 0
+                            select remotePlugin;
+      if (pluginsToUpdate.Count() > 0) {
+        installationManager.Update(pluginsToUpdate);
+        pluginManager.DiscoverAndCheckPlugins();
+        e.Cancel = false;
+      } else {
+        e.Cancel = true;
+      }
+    }
+
+    private bool IsNewerThan(IPluginDescription plugin1, IPluginDescription plugin2) {
+      // newer: build version is higher, or if build version is the same revision is higher
+      if (plugin1.Version.Build < plugin2.Version.Build) return false;
+      else if (plugin1.Version.Build > plugin2.Version.Build) return true;
+      else return plugin1.Version.Revision > plugin2.Version.Revision;
+    }
+
+    #endregion
+    private void updateAndInstallButton_Click(object sender, EventArgs e) {
+      var installedPlugins = pluginManager.Plugins.OfType<IPluginDescription>().ToList();
+      updatePluginsBackgroundWorker.RunWorkerAsync(installedPlugins);
+      StatusView.LockUI();
+      StatusView.ShowProgressIndicator();
+      StatusView.RemoveMessage(NoUpdatesAvailableMessage);
+      StatusView.ShowMessage(CheckingPluginsMessage);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/IStatusDisplay.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/IStatusDisplay.cs	(revision 3547)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/IStatusDisplay.cs	(revision 3547)
@@ -0,0 +1,44 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2010 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.PluginInfrastructure.Manager;
+using System.IO;
+using System.ComponentModel;
+using System.Reflection;
+using ICSharpCode.SharpZipLib.Zip;
+using System.ServiceModel;
+
+namespace HeuristicLab.PluginInfrastructure.Advanced {
+  internal interface IStatusView {
+    void ShowProgressIndicator(double percentProgress);
+    void ShowProgressIndicator();
+    void HideProgressIndicator();
+    void ShowMessage(string message);
+    void RemoveMessage(string message);
+    void LockUI();
+    void UnlockUI();
+    void ShowError(string shortMessage, string description);
+  }
+}
Index: /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerControl.cs
===================================================================
--- /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerControl.cs	(revision 3546)
+++ /trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/InstallationManagerControl.cs	(revision 3547)
@@ -30,15 +30,13 @@
 namespace HeuristicLab.PluginInfrastructure.Advanced {
   internal partial class InstallationManagerControl : UserControl {
-    public InstallationManagerControl() {
-      InitializeComponent();
+    private IStatusView statusView;
+    public IStatusView StatusView {
+      get { return statusView; }
+      set { statusView = value; }
     }
 
-    internal virtual void ShowInForm() {
-      Form form = new Form();
-      form.ClientSize = this.Size;
-      form.Text = this.Name;
-      this.Dock = DockStyle.Fill;
-      form.Controls.Add(this);
-      form.Show();
+    public InstallationManagerControl()
+      : base() {
+      InitializeComponent();
     }
   }
